<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: auto_mutex_extension_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_a969b683060659f05db598aa6ff40bd8.html">threads</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">auto_mutex_extension_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2005  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_AUTO_MUTEX_EXTENSIOn_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_AUTO_MUTEX_EXTENSIOn_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;threads_kernel_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;rmutex_extension_abstract.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;read_write_mutex_extension_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;{</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="keyword">class </span>auto_mutex</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    {</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keyword">explicit</span> <a class="code" href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">auto_mutex</a> (</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;            <span class="keyword">const</span> mutex&amp; m</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        );</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keyword">explicit</span> <a class="code" href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">auto_mutex</a> (</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            <span class="keyword">const</span> rmutex&amp; m</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        );</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keyword">explicit</span> <a class="code" href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">auto_mutex</a> (</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            <span class="keyword">const</span> read_write_mutex&amp; m</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        );</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keywordtype">void</span> unlock(</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        );</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        ~<a class="code" href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">auto_mutex</a> (</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        );</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="comment">// restricted functions</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <a class="code" href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">auto_mutex</a>(<a class="code" href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">auto_mutex</a>&amp;);        <span class="comment">// copy constructor</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <a class="code" href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">auto_mutex</a>&amp; operator=(<a class="code" href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">auto_mutex</a>&amp;);    <span class="comment">// assignment operator</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    };</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keyword">class </span>auto_mutex_readonly</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    {</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keyword">explicit</span> auto_mutex_readonly (</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="keyword">const</span> read_write_mutex&amp; m</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        );</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        ~auto_mutex_readonly (</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        );</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordtype">bool</span> has_read_lock (</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        );</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="keywordtype">bool</span> has_write_lock (</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        ); </div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <span class="keywordtype">void</span> lock_readonly (</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        );</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="keywordtype">void</span> lock_write (</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        );</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <span class="keywordtype">void</span> unlock (</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        );</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="comment">// restricted functions</span></div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        auto_mutex_readonly(auto_mutex_readonly&amp;);        <span class="comment">// copy constructor</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        auto_mutex_readonly&amp; operator=(auto_mutex_readonly&amp;);    <span class="comment">// assignment operator</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    };</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160; </div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160; </div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;}</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160; </div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;<span class="preprocessor">#endif // DLIB_AUTO_MUTEX_EXTENSIOn_ABSTRACT_</span></div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1auto__mutex_html_a4f46cbabea8d135cfb2b53a501743f1c"><div class="ttname"><a href="classdlib_1_1auto__mutex.html#a4f46cbabea8d135cfb2b53a501743f1c">dlib::auto_mutex::auto_mutex</a></div><div class="ttdeci">auto_mutex(const mutex &amp;m_)</div><div class="ttdef"><b>Definition:</b> auto_mutex_extension.h:39</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
